import { Mutex } from 'async-mutex';
import { ethers } from 'ethers';
export interface CustomProvider {
    url: string;
    provider?: ethers.providers.WebSocketProvider;
    connectedAt: number;
    connected?: boolean;
    blockHeight?: number;
}
export declare class ActiveProvider {
    urls: Array<string>;
    urlIndex: number;
    healthAlert?: (error: Error) => void;
    lastBlockReceivedAt: number;
    private interval;
    mutex: Mutex;
    keepAliveInterval: any;
    constructor(urls: Array<string>, interval?: number, idleTimeout?: number, healthAlert?: (error: Error) => void);
    index: number;
    incrementIndex: () => void;
    getUrl: () => string;
    connectionWatchdog: (threshold: number) => void;
    reset: () => void;
    preferredProvider: () => boolean;
    destroyProvider: (provider?: ethers.providers.WebSocketProvider) => Promise<void>;
    selectProvider: (forceRenewal: boolean, currentProvider?: CustomProvider) => Promise<CustomProvider>;
    run: (forceRenewal: boolean, currentProvider?: CustomProvider) => Promise<CustomProvider>;
    addListeners: (url: string, _provider: ethers.providers.WebSocketProvider) => void;
}
